---
title: Create a new Action Connection
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Action Connection
---

# Create a new Action Connection{% #create-a-new-action-connection %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                  |
| ----------------- | ------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/actions/connections |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/actions/connections |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/actions/connections      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/actions/connections      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/actions/connections  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/actions/connections     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/actions/connections |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/actions/connections |

### Overview

Create a new Action Connection. This API requires a [registered application key](https://docs.datadoghq.com/api/latest/action-connection.md#register-a-new-app-key).

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field   | Field                                   | Type          | Description                                                                                                                                                                                                                                                                                                                                                                           |
| -------------- | --------------------------------------- | ------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                | data [*required*]                  | object        | Data related to the connection.                                                                                                                                                                                                                                                                                                                                                       |
| data           | attributes [*required*]            | object        | The definition of `ActionConnectionAttributes` object.                                                                                                                                                                                                                                                                                                                                |
| attributes     | integration [*required*]           |  <oneOf> | The definition of `ActionConnectionIntegration` object.                                                                                                                                                                                                                                                                                                                               |
| integration    | Option 1                                | object        | The definition of `AWSIntegration` object.                                                                                                                                                                                                                                                                                                                                            |
| Option 1       | credentials [*required*]           |  <oneOf> | The definition of `AWSCredentials` object.                                                                                                                                                                                                                                                                                                                                            |
| credentials    | Option 1                                | object        | The definition of `AWSAssumeRole` object.                                                                                                                                                                                                                                                                                                                                             |
| Option 1       | account_id [*required*]            | string        | AWS account the connection is created for                                                                                                                                                                                                                                                                                                                                             |
| Option 1       | external_id                             | string        | External ID used to scope which connection can be used to assume the role                                                                                                                                                                                                                                                                                                             |
| Option 1       | principal_id                            | string        | AWS account that will assume the role                                                                                                                                                                                                                                                                                                                                                 |
| Option 1       | role [*required*]                  | string        | Role to assume                                                                                                                                                                                                                                                                                                                                                                        |
| Option 1       | type [*required*]                  | enum          | The definition of `AWSAssumeRoleType` object. Allowed enum values: `AWSAssumeRole`                                                                                                                                                                                                                                                                                                    |
| Option 1       | type [*required*]                  | enum          | The definition of `AWSIntegrationType` object. Allowed enum values: `AWS`                                                                                                                                                                                                                                                                                                             |
| integration    | Option 2                                | object        | The definition of the `AnthropicIntegration` object.                                                                                                                                                                                                                                                                                                                                  |
| Option 2       | credentials [*required*]           |  <oneOf> | The definition of the `AnthropicCredentials` object.                                                                                                                                                                                                                                                                                                                                  |
| credentials    | Option 1                                | object        | The definition of the `AnthropicAPIKey` object.                                                                                                                                                                                                                                                                                                                                       |
| Option 1       | api_token [*required*]             | string        | The `AnthropicAPIKey` `api_token`.                                                                                                                                                                                                                                                                                                                                                    |
| Option 1       | type [*required*]                  | enum          | The definition of the `AnthropicAPIKey` object. Allowed enum values: `AnthropicAPIKey`                                                                                                                                                                                                                                                                                                |
| Option 2       | type [*required*]                  | enum          | The definition of the `AnthropicIntegrationType` object. Allowed enum values: `Anthropic`                                                                                                                                                                                                                                                                                             |
| integration    | Option 3                                | object        | The definition of the `AsanaIntegration` object.                                                                                                                                                                                                                                                                                                                                      |
| Option 3       | credentials [*required*]           |  <oneOf> | The definition of the `AsanaCredentials` object.                                                                                                                                                                                                                                                                                                                                      |
| credentials    | Option 1                                | object        | The definition of the `AsanaAccessToken` object.                                                                                                                                                                                                                                                                                                                                      |
| Option 1       | access_token [*required*]          | string        | The `AsanaAccessToken` `access_token`.                                                                                                                                                                                                                                                                                                                                                |
| Option 1       | type [*required*]                  | enum          | The definition of the `AsanaAccessToken` object. Allowed enum values: `AsanaAccessToken`                                                                                                                                                                                                                                                                                              |
| Option 3       | type [*required*]                  | enum          | The definition of the `AsanaIntegrationType` object. Allowed enum values: `Asana`                                                                                                                                                                                                                                                                                                     |
| integration    | Option 4                                | object        | The definition of the `AzureIntegration` object.                                                                                                                                                                                                                                                                                                                                      |
| Option 4       | credentials [*required*]           |  <oneOf> | The definition of the `AzureCredentials` object.                                                                                                                                                                                                                                                                                                                                      |
| credentials    | Option 1                                | object        | The definition of the `AzureTenant` object.                                                                                                                                                                                                                                                                                                                                           |
| Option 1       | app_client_id [*required*]         | string        | The Client ID, also known as the Application ID in Azure, is a unique identifier for an application. It's used to identify the application during the authentication process. Your Application (client) ID is listed in the application's overview page. You can navigate to your application via the Azure Directory.                                                                |
| Option 1       | client_secret [*required*]         | string        | The Client Secret is a confidential piece of information known only to the application and Azure AD. It's used to prove the application's identity. Your Client Secret is available from the application's secrets page. You can navigate to your application via the Azure Directory.                                                                                                |
| Option 1       | custom_scopes                           | string        | If provided, the custom scope to be requested from Microsoft when acquiring an OAuth 2 access token. This custom scope is used only in conjunction with the HTTP action. A resource's scope is constructed by using the identifier URI for the resource and .default, separated by a forward slash (/) as follows:{identifierURI}/.default.                                           |
| Option 1       | tenant_id [*required*]             | string        | The Tenant ID, also known as the Directory ID in Azure, is a unique identifier that represents an Azure AD instance. Your Tenant ID (Directory ID) is listed in your Active Directory overview page under the 'Tenant information' section.                                                                                                                                           |
| Option 1       | type [*required*]                  | enum          | The definition of the `AzureTenant` object. Allowed enum values: `AzureTenant`                                                                                                                                                                                                                                                                                                        |
| Option 4       | type [*required*]                  | enum          | The definition of the `AzureIntegrationType` object. Allowed enum values: `Azure`                                                                                                                                                                                                                                                                                                     |
| integration    | Option 5                                | object        | The definition of the `CircleCIIntegration` object.                                                                                                                                                                                                                                                                                                                                   |
| Option 5       | credentials [*required*]           |  <oneOf> | The definition of the `CircleCICredentials` object.                                                                                                                                                                                                                                                                                                                                   |
| credentials    | Option 1                                | object        | The definition of the `CircleCIAPIKey` object.                                                                                                                                                                                                                                                                                                                                        |
| Option 1       | api_token [*required*]             | string        | The `CircleCIAPIKey` `api_token`.                                                                                                                                                                                                                                                                                                                                                     |
| Option 1       | type [*required*]                  | enum          | The definition of the `CircleCIAPIKey` object. Allowed enum values: `CircleCIAPIKey`                                                                                                                                                                                                                                                                                                  |
| Option 5       | type [*required*]                  | enum          | The definition of the `CircleCIIntegrationType` object. Allowed enum values: `CircleCI`                                                                                                                                                                                                                                                                                               |
| integration    | Option 6                                | object        | The definition of the `ClickupIntegration` object.                                                                                                                                                                                                                                                                                                                                    |
| Option 6       | credentials [*required*]           |  <oneOf> | The definition of the `ClickupCredentials` object.                                                                                                                                                                                                                                                                                                                                    |
| credentials    | Option 1                                | object        | The definition of the `ClickupAPIKey` object.                                                                                                                                                                                                                                                                                                                                         |
| Option 1       | api_token [*required*]             | string        | The `ClickupAPIKey` `api_token`.                                                                                                                                                                                                                                                                                                                                                      |
| Option 1       | type [*required*]                  | enum          | The definition of the `ClickupAPIKey` object. Allowed enum values: `ClickupAPIKey`                                                                                                                                                                                                                                                                                                    |
| Option 6       | type [*required*]                  | enum          | The definition of the `ClickupIntegrationType` object. Allowed enum values: `Clickup`                                                                                                                                                                                                                                                                                                 |
| integration    | Option 7                                | object        | The definition of the `CloudflareIntegration` object.                                                                                                                                                                                                                                                                                                                                 |
| Option 7       | credentials [*required*]           |  <oneOf> | The definition of the `CloudflareCredentials` object.                                                                                                                                                                                                                                                                                                                                 |
| credentials    | Option 1                                | object        | The definition of the `CloudflareAPIToken` object.                                                                                                                                                                                                                                                                                                                                    |
| Option 1       | api_token [*required*]             | string        | The `CloudflareAPIToken` `api_token`.                                                                                                                                                                                                                                                                                                                                                 |
| Option 1       | type [*required*]                  | enum          | The definition of the `CloudflareAPIToken` object. Allowed enum values: `CloudflareAPIToken`                                                                                                                                                                                                                                                                                          |
| credentials    | Option 2                                | object        | The definition of the `CloudflareGlobalAPIToken` object.                                                                                                                                                                                                                                                                                                                              |
| Option 2       | auth_email [*required*]            | string        | The `CloudflareGlobalAPIToken` `auth_email`.                                                                                                                                                                                                                                                                                                                                          |
| Option 2       | global_api_key [*required*]        | string        | The `CloudflareGlobalAPIToken` `global_api_key`.                                                                                                                                                                                                                                                                                                                                      |
| Option 2       | type [*required*]                  | enum          | The definition of the `CloudflareGlobalAPIToken` object. Allowed enum values: `CloudflareGlobalAPIToken`                                                                                                                                                                                                                                                                              |
| Option 7       | type [*required*]                  | enum          | The definition of the `CloudflareIntegrationType` object. Allowed enum values: `Cloudflare`                                                                                                                                                                                                                                                                                           |
| integration    | Option 8                                | object        | The definition of the `ConfigCatIntegration` object.                                                                                                                                                                                                                                                                                                                                  |
| Option 8       | credentials [*required*]           |  <oneOf> | The definition of the `ConfigCatCredentials` object.                                                                                                                                                                                                                                                                                                                                  |
| credentials    | Option 1                                | object        | The definition of the `ConfigCatSDKKey` object.                                                                                                                                                                                                                                                                                                                                       |
| Option 1       | api_password [*required*]          | string        | The `ConfigCatSDKKey` `api_password`.                                                                                                                                                                                                                                                                                                                                                 |
| Option 1       | api_username [*required*]          | string        | The `ConfigCatSDKKey` `api_username`.                                                                                                                                                                                                                                                                                                                                                 |
| Option 1       | sdk_key [*required*]               | string        | The `ConfigCatSDKKey` `sdk_key`.                                                                                                                                                                                                                                                                                                                                                      |
| Option 1       | type [*required*]                  | enum          | The definition of the `ConfigCatSDKKey` object. Allowed enum values: `ConfigCatSDKKey`                                                                                                                                                                                                                                                                                                |
| Option 8       | type [*required*]                  | enum          | The definition of the `ConfigCatIntegrationType` object. Allowed enum values: `ConfigCat`                                                                                                                                                                                                                                                                                             |
| integration    | Option 9                                | object        | The definition of the `DatadogIntegration` object.                                                                                                                                                                                                                                                                                                                                    |
| Option 9       | credentials [*required*]           |  <oneOf> | The definition of the `DatadogCredentials` object.                                                                                                                                                                                                                                                                                                                                    |
| credentials    | Option 1                                | object        | The definition of the `DatadogAPIKey` object.                                                                                                                                                                                                                                                                                                                                         |
| Option 1       | api_key [*required*]               | string        | The `DatadogAPIKey` `api_key`.                                                                                                                                                                                                                                                                                                                                                        |
| Option 1       | app_key [*required*]               | string        | The `DatadogAPIKey` `app_key`.                                                                                                                                                                                                                                                                                                                                                        |
| Option 1       | datacenter [*required*]            | string        | The `DatadogAPIKey` `datacenter`.                                                                                                                                                                                                                                                                                                                                                     |
| Option 1       | subdomain                               | string        | Custom subdomain used for Datadog URLs generated with this Connection. For example, if this org uses `https://acme.datadoghq.com` to access Datadog, set this field to `acme`. If this field is omitted, generated URLs will use the default site URL for its datacenter (see [https://docs.datadoghq.com/getting_started/site](https://docs.datadoghq.com/getting_started/site.md)). |
| Option 1       | type [*required*]                  | enum          | The definition of the `DatadogAPIKey` object. Allowed enum values: `DatadogAPIKey`                                                                                                                                                                                                                                                                                                    |
| Option 9       | type [*required*]                  | enum          | The definition of the `DatadogIntegrationType` object. Allowed enum values: `Datadog`                                                                                                                                                                                                                                                                                                 |
| integration    | Option 10                               | object        | The definition of the `FastlyIntegration` object.                                                                                                                                                                                                                                                                                                                                     |
| Option 10      | credentials [*required*]           |  <oneOf> | The definition of the `FastlyCredentials` object.                                                                                                                                                                                                                                                                                                                                     |
| credentials    | Option 1                                | object        | The definition of the `FastlyAPIKey` object.                                                                                                                                                                                                                                                                                                                                          |
| Option 1       | api_key [*required*]               | string        | The `FastlyAPIKey` `api_key`.                                                                                                                                                                                                                                                                                                                                                         |
| Option 1       | type [*required*]                  | enum          | The definition of the `FastlyAPIKey` object. Allowed enum values: `FastlyAPIKey`                                                                                                                                                                                                                                                                                                      |
| Option 10      | type [*required*]                  | enum          | The definition of the `FastlyIntegrationType` object. Allowed enum values: `Fastly`                                                                                                                                                                                                                                                                                                   |
| integration    | Option 11                               | object        | The definition of the `FreshserviceIntegration` object.                                                                                                                                                                                                                                                                                                                               |
| Option 11      | credentials [*required*]           |  <oneOf> | The definition of the `FreshserviceCredentials` object.                                                                                                                                                                                                                                                                                                                               |
| credentials    | Option 1                                | object        | The definition of the `FreshserviceAPIKey` object.                                                                                                                                                                                                                                                                                                                                    |
| Option 1       | api_key [*required*]               | string        | The `FreshserviceAPIKey` `api_key`.                                                                                                                                                                                                                                                                                                                                                   |
| Option 1       | domain [*required*]                | string        | The `FreshserviceAPIKey` `domain`.                                                                                                                                                                                                                                                                                                                                                    |
| Option 1       | type [*required*]                  | enum          | The definition of the `FreshserviceAPIKey` object. Allowed enum values: `FreshserviceAPIKey`                                                                                                                                                                                                                                                                                          |
| Option 11      | type [*required*]                  | enum          | The definition of the `FreshserviceIntegrationType` object. Allowed enum values: `Freshservice`                                                                                                                                                                                                                                                                                       |
| integration    | Option 12                               | object        | The definition of the `GCPIntegration` object.                                                                                                                                                                                                                                                                                                                                        |
| Option 12      | credentials [*required*]           |  <oneOf> | The definition of the `GCPCredentials` object.                                                                                                                                                                                                                                                                                                                                        |
| credentials    | Option 1                                | object        | The definition of the `GCPServiceAccount` object.                                                                                                                                                                                                                                                                                                                                     |
| Option 1       | private_key [*required*]           | string        | The `GCPServiceAccount` `private_key`.                                                                                                                                                                                                                                                                                                                                                |
| Option 1       | service_account_email [*required*] | string        | The `GCPServiceAccount` `service_account_email`.                                                                                                                                                                                                                                                                                                                                      |
| Option 1       | type [*required*]                  | enum          | The definition of the `GCPServiceAccount` object. Allowed enum values: `GCPServiceAccount`                                                                                                                                                                                                                                                                                            |
| Option 12      | type [*required*]                  | enum          | The definition of the `GCPIntegrationType` object. Allowed enum values: `GCP`                                                                                                                                                                                                                                                                                                         |
| integration    | Option 13                               | object        | The definition of the `GeminiIntegration` object.                                                                                                                                                                                                                                                                                                                                     |
| Option 13      | credentials [*required*]           |  <oneOf> | The definition of the `GeminiCredentials` object.                                                                                                                                                                                                                                                                                                                                     |
| credentials    | Option 1                                | object        | The definition of the `GeminiAPIKey` object.                                                                                                                                                                                                                                                                                                                                          |
| Option 1       | api_key [*required*]               | string        | The `GeminiAPIKey` `api_key`.                                                                                                                                                                                                                                                                                                                                                         |
| Option 1       | type [*required*]                  | enum          | The definition of the `GeminiAPIKey` object. Allowed enum values: `GeminiAPIKey`                                                                                                                                                                                                                                                                                                      |
| Option 13      | type [*required*]                  | enum          | The definition of the `GeminiIntegrationType` object. Allowed enum values: `Gemini`                                                                                                                                                                                                                                                                                                   |
| integration    | Option 14                               | object        | The definition of the `GitlabIntegration` object.                                                                                                                                                                                                                                                                                                                                     |
| Option 14      | credentials [*required*]           |  <oneOf> | The definition of the `GitlabCredentials` object.                                                                                                                                                                                                                                                                                                                                     |
| credentials    | Option 1                                | object        | The definition of the `GitlabAPIKey` object.                                                                                                                                                                                                                                                                                                                                          |
| Option 1       | api_token [*required*]             | string        | The `GitlabAPIKey` `api_token`.                                                                                                                                                                                                                                                                                                                                                       |
| Option 1       | type [*required*]                  | enum          | The definition of the `GitlabAPIKey` object. Allowed enum values: `GitlabAPIKey`                                                                                                                                                                                                                                                                                                      |
| Option 14      | type [*required*]                  | enum          | The definition of the `GitlabIntegrationType` object. Allowed enum values: `Gitlab`                                                                                                                                                                                                                                                                                                   |
| integration    | Option 15                               | object        | The definition of the `GreyNoiseIntegration` object.                                                                                                                                                                                                                                                                                                                                  |
| Option 15      | credentials [*required*]           |  <oneOf> | The definition of the `GreyNoiseCredentials` object.                                                                                                                                                                                                                                                                                                                                  |
| credentials    | Option 1                                | object        | The definition of the `GreyNoiseAPIKey` object.                                                                                                                                                                                                                                                                                                                                       |
| Option 1       | api_key [*required*]               | string        | The `GreyNoiseAPIKey` `api_key`.                                                                                                                                                                                                                                                                                                                                                      |
| Option 1       | type [*required*]                  | enum          | The definition of the `GreyNoiseAPIKey` object. Allowed enum values: `GreyNoiseAPIKey`                                                                                                                                                                                                                                                                                                |
| Option 15      | type [*required*]                  | enum          | The definition of the `GreyNoiseIntegrationType` object. Allowed enum values: `GreyNoise`                                                                                                                                                                                                                                                                                             |
| integration    | Option 16                               | object        | The definition of `HTTPIntegration` object.                                                                                                                                                                                                                                                                                                                                           |
| Option 16      | base_url [*required*]              | string        | Base HTTP url for the integration                                                                                                                                                                                                                                                                                                                                                     |
| Option 16      | credentials [*required*]           |  <oneOf> | The definition of `HTTPCredentials` object.                                                                                                                                                                                                                                                                                                                                           |
| credentials    | Option 1                                | object        | The definition of `HTTPTokenAuth` object.                                                                                                                                                                                                                                                                                                                                             |
| Option 1       | body                                    | object        | The definition of `HTTPBody` object.                                                                                                                                                                                                                                                                                                                                                  |
| body           | content                                 | string        | Serialized body content                                                                                                                                                                                                                                                                                                                                                               |
| body           | content_type                            | string        | Content type of the body                                                                                                                                                                                                                                                                                                                                                              |
| Option 1       | headers                                 | [object]      | The `HTTPTokenAuth` `headers`.                                                                                                                                                                                                                                                                                                                                                        |
| headers        | name [*required*]                  | string        | The `HTTPHeader` `name`.                                                                                                                                                                                                                                                                                                                                                              |
| headers        | value [*required*]                 | string        | The `HTTPHeader` `value`.                                                                                                                                                                                                                                                                                                                                                             |
| Option 1       | tokens                                  | [object]      | The `HTTPTokenAuth` `tokens`.                                                                                                                                                                                                                                                                                                                                                         |
| tokens         | name [*required*]                  | string        | The `HTTPToken` `name`.                                                                                                                                                                                                                                                                                                                                                               |
| tokens         | type [*required*]                  | enum          | The definition of `TokenType` object. Allowed enum values: `SECRET`                                                                                                                                                                                                                                                                                                                   |
| tokens         | value [*required*]                 | string        | The `HTTPToken` `value`.                                                                                                                                                                                                                                                                                                                                                              |
| Option 1       | type [*required*]                  | enum          | The definition of `HTTPTokenAuthType` object. Allowed enum values: `HTTPTokenAuth`                                                                                                                                                                                                                                                                                                    |
| Option 1       | url_parameters                          | [object]      | The `HTTPTokenAuth` `url_parameters`.                                                                                                                                                                                                                                                                                                                                                 |
| url_parameters | name [*required*]                  | string        | Name for tokens.                                                                                                                                                                                                                                                                                                                                                                      |
| url_parameters | value [*required*]                 | string        | The `UrlParam` `value`.                                                                                                                                                                                                                                                                                                                                                               |
| Option 16      | type [*required*]                  | enum          | The definition of `HTTPIntegrationType` object. Allowed enum values: `HTTP`                                                                                                                                                                                                                                                                                                           |
| integration    | Option 17                               | object        | The definition of the `LaunchDarklyIntegration` object.                                                                                                                                                                                                                                                                                                                               |
| Option 17      | credentials [*required*]           |  <oneOf> | The definition of the `LaunchDarklyCredentials` object.                                                                                                                                                                                                                                                                                                                               |
| credentials    | Option 1                                | object        | The definition of the `LaunchDarklyAPIKey` object.                                                                                                                                                                                                                                                                                                                                    |
| Option 1       | api_token [*required*]             | string        | The `LaunchDarklyAPIKey` `api_token`.                                                                                                                                                                                                                                                                                                                                                 |
| Option 1       | type [*required*]                  | enum          | The definition of the `LaunchDarklyAPIKey` object. Allowed enum values: `LaunchDarklyAPIKey`                                                                                                                                                                                                                                                                                          |
| Option 17      | type [*required*]                  | enum          | The definition of the `LaunchDarklyIntegrationType` object. Allowed enum values: `LaunchDarkly`                                                                                                                                                                                                                                                                                       |
| integration    | Option 18                               | object        | The definition of the `NotionIntegration` object.                                                                                                                                                                                                                                                                                                                                     |
| Option 18      | credentials [*required*]           |  <oneOf> | The definition of the `NotionCredentials` object.                                                                                                                                                                                                                                                                                                                                     |
| credentials    | Option 1                                | object        | The definition of the `NotionAPIKey` object.                                                                                                                                                                                                                                                                                                                                          |
| Option 1       | api_token [*required*]             | string        | The `NotionAPIKey` `api_token`.                                                                                                                                                                                                                                                                                                                                                       |
| Option 1       | type [*required*]                  | enum          | The definition of the `NotionAPIKey` object. Allowed enum values: `NotionAPIKey`                                                                                                                                                                                                                                                                                                      |
| Option 18      | type [*required*]                  | enum          | The definition of the `NotionIntegrationType` object. Allowed enum values: `Notion`                                                                                                                                                                                                                                                                                                   |
| integration    | Option 19                               | object        | The definition of the `OktaIntegration` object.                                                                                                                                                                                                                                                                                                                                       |
| Option 19      | credentials [*required*]           |  <oneOf> | The definition of the `OktaCredentials` object.                                                                                                                                                                                                                                                                                                                                       |
| credentials    | Option 1                                | object        | The definition of the `OktaAPIToken` object.                                                                                                                                                                                                                                                                                                                                          |
| Option 1       | api_token [*required*]             | string        | The `OktaAPIToken` `api_token`.                                                                                                                                                                                                                                                                                                                                                       |
| Option 1       | domain [*required*]                | string        | The `OktaAPIToken` `domain`.                                                                                                                                                                                                                                                                                                                                                          |
| Option 1       | type [*required*]                  | enum          | The definition of the `OktaAPIToken` object. Allowed enum values: `OktaAPIToken`                                                                                                                                                                                                                                                                                                      |
| Option 19      | type [*required*]                  | enum          | The definition of the `OktaIntegrationType` object. Allowed enum values: `Okta`                                                                                                                                                                                                                                                                                                       |
| integration    | Option 20                               | object        | The definition of the `OpenAIIntegration` object.                                                                                                                                                                                                                                                                                                                                     |
| Option 20      | credentials [*required*]           |  <oneOf> | The definition of the `OpenAICredentials` object.                                                                                                                                                                                                                                                                                                                                     |
| credentials    | Option 1                                | object        | The definition of the `OpenAIAPIKey` object.                                                                                                                                                                                                                                                                                                                                          |
| Option 1       | api_token [*required*]             | string        | The `OpenAIAPIKey` `api_token`.                                                                                                                                                                                                                                                                                                                                                       |
| Option 1       | type [*required*]                  | enum          | The definition of the `OpenAIAPIKey` object. Allowed enum values: `OpenAIAPIKey`                                                                                                                                                                                                                                                                                                      |
| Option 20      | type [*required*]                  | enum          | The definition of the `OpenAIIntegrationType` object. Allowed enum values: `OpenAI`                                                                                                                                                                                                                                                                                                   |
| integration    | Option 21                               | object        | The definition of the `ServiceNowIntegration` object.                                                                                                                                                                                                                                                                                                                                 |
| Option 21      | credentials [*required*]           |  <oneOf> | The definition of the `ServiceNowCredentials` object.                                                                                                                                                                                                                                                                                                                                 |
| credentials    | Option 1                                | object        | The definition of the `ServiceNowBasicAuth` object.                                                                                                                                                                                                                                                                                                                                   |
| Option 1       | instance [*required*]              | string        | The `ServiceNowBasicAuth` `instance`.                                                                                                                                                                                                                                                                                                                                                 |
| Option 1       | password [*required*]              | string        | The `ServiceNowBasicAuth` `password`.                                                                                                                                                                                                                                                                                                                                                 |
| Option 1       | type [*required*]                  | enum          | The definition of the `ServiceNowBasicAuth` object. Allowed enum values: `ServiceNowBasicAuth`                                                                                                                                                                                                                                                                                        |
| Option 1       | username [*required*]              | string        | The `ServiceNowBasicAuth` `username`.                                                                                                                                                                                                                                                                                                                                                 |
| Option 21      | type [*required*]                  | enum          | The definition of the `ServiceNowIntegrationType` object. Allowed enum values: `ServiceNow`                                                                                                                                                                                                                                                                                           |
| integration    | Option 22                               | object        | The definition of the `SplitIntegration` object.                                                                                                                                                                                                                                                                                                                                      |
| Option 22      | credentials [*required*]           |  <oneOf> | The definition of the `SplitCredentials` object.                                                                                                                                                                                                                                                                                                                                      |
| credentials    | Option 1                                | object        | The definition of the `SplitAPIKey` object.                                                                                                                                                                                                                                                                                                                                           |
| Option 1       | api_key [*required*]               | string        | The `SplitAPIKey` `api_key`.                                                                                                                                                                                                                                                                                                                                                          |
| Option 1       | type [*required*]                  | enum          | The definition of the `SplitAPIKey` object. Allowed enum values: `SplitAPIKey`                                                                                                                                                                                                                                                                                                        |
| Option 22      | type [*required*]                  | enum          | The definition of the `SplitIntegrationType` object. Allowed enum values: `Split`                                                                                                                                                                                                                                                                                                     |
| integration    | Option 23                               | object        | The definition of the `StatsigIntegration` object.                                                                                                                                                                                                                                                                                                                                    |
| Option 23      | credentials [*required*]           |  <oneOf> | The definition of the `StatsigCredentials` object.                                                                                                                                                                                                                                                                                                                                    |
| credentials    | Option 1                                | object        | The definition of the `StatsigAPIKey` object.                                                                                                                                                                                                                                                                                                                                         |
| Option 1       | api_key [*required*]               | string        | The `StatsigAPIKey` `api_key`.                                                                                                                                                                                                                                                                                                                                                        |
| Option 1       | type [*required*]                  | enum          | The definition of the `StatsigAPIKey` object. Allowed enum values: `StatsigAPIKey`                                                                                                                                                                                                                                                                                                    |
| Option 23      | type [*required*]                  | enum          | The definition of the `StatsigIntegrationType` object. Allowed enum values: `Statsig`                                                                                                                                                                                                                                                                                                 |
| integration    | Option 24                               | object        | The definition of the `VirusTotalIntegration` object.                                                                                                                                                                                                                                                                                                                                 |
| Option 24      | credentials [*required*]           |  <oneOf> | The definition of the `VirusTotalCredentials` object.                                                                                                                                                                                                                                                                                                                                 |
| credentials    | Option 1                                | object        | The definition of the `VirusTotalAPIKey` object.                                                                                                                                                                                                                                                                                                                                      |
| Option 1       | api_key [*required*]               | string        | The `VirusTotalAPIKey` `api_key`.                                                                                                                                                                                                                                                                                                                                                     |
| Option 1       | type [*required*]                  | enum          | The definition of the `VirusTotalAPIKey` object. Allowed enum values: `VirusTotalAPIKey`                                                                                                                                                                                                                                                                                              |
| Option 24      | type [*required*]                  | enum          | The definition of the `VirusTotalIntegrationType` object. Allowed enum values: `VirusTotal`                                                                                                                                                                                                                                                                                           |
| attributes     | name [*required*]                  | string        | Name of the connection                                                                                                                                                                                                                                                                                                                                                                |
| data           | id                                      | string        | The connection identifier                                                                                                                                                                                                                                                                                                                                                             |
| data           | type [*required*]                  | enum          | The definition of `ActionConnectionDataType` object. Allowed enum values: `action_connection`                                                                                                                                                                                                                                                                                         |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "type": "action_connection",
    "attributes": {
      "name": "Cassette Connection exampleactionconnection",
      "integration": {
        "type": "AWS",
        "credentials": {
          "type": "AWSAssumeRole",
          "role": "MyRoleUpdated",
          "account_id": "123456789123"
        }
      }
    }
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Successfully created Action Connection
{% tab title="Model" %}
The response for a created connection

| Parent field   | Field                                   | Type          | Description                                                                                                                                                                                                                                                                                                                                                                           |
| -------------- | --------------------------------------- | ------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                | data                                    | object        | Data related to the connection.                                                                                                                                                                                                                                                                                                                                                       |
| data           | attributes [*required*]            | object        | The definition of `ActionConnectionAttributes` object.                                                                                                                                                                                                                                                                                                                                |
| attributes     | integration [*required*]           |  <oneOf> | The definition of `ActionConnectionIntegration` object.                                                                                                                                                                                                                                                                                                                               |
| integration    | Option 1                                | object        | The definition of `AWSIntegration` object.                                                                                                                                                                                                                                                                                                                                            |
| Option 1       | credentials [*required*]           |  <oneOf> | The definition of `AWSCredentials` object.                                                                                                                                                                                                                                                                                                                                            |
| credentials    | Option 1                                | object        | The definition of `AWSAssumeRole` object.                                                                                                                                                                                                                                                                                                                                             |
| Option 1       | account_id [*required*]            | string        | AWS account the connection is created for                                                                                                                                                                                                                                                                                                                                             |
| Option 1       | external_id                             | string        | External ID used to scope which connection can be used to assume the role                                                                                                                                                                                                                                                                                                             |
| Option 1       | principal_id                            | string        | AWS account that will assume the role                                                                                                                                                                                                                                                                                                                                                 |
| Option 1       | role [*required*]                  | string        | Role to assume                                                                                                                                                                                                                                                                                                                                                                        |
| Option 1       | type [*required*]                  | enum          | The definition of `AWSAssumeRoleType` object. Allowed enum values: `AWSAssumeRole`                                                                                                                                                                                                                                                                                                    |
| Option 1       | type [*required*]                  | enum          | The definition of `AWSIntegrationType` object. Allowed enum values: `AWS`                                                                                                                                                                                                                                                                                                             |
| integration    | Option 2                                | object        | The definition of the `AnthropicIntegration` object.                                                                                                                                                                                                                                                                                                                                  |
| Option 2       | credentials [*required*]           |  <oneOf> | The definition of the `AnthropicCredentials` object.                                                                                                                                                                                                                                                                                                                                  |
| credentials    | Option 1                                | object        | The definition of the `AnthropicAPIKey` object.                                                                                                                                                                                                                                                                                                                                       |
| Option 1       | api_token [*required*]             | string        | The `AnthropicAPIKey` `api_token`.                                                                                                                                                                                                                                                                                                                                                    |
| Option 1       | type [*required*]                  | enum          | The definition of the `AnthropicAPIKey` object. Allowed enum values: `AnthropicAPIKey`                                                                                                                                                                                                                                                                                                |
| Option 2       | type [*required*]                  | enum          | The definition of the `AnthropicIntegrationType` object. Allowed enum values: `Anthropic`                                                                                                                                                                                                                                                                                             |
| integration    | Option 3                                | object        | The definition of the `AsanaIntegration` object.                                                                                                                                                                                                                                                                                                                                      |
| Option 3       | credentials [*required*]           |  <oneOf> | The definition of the `AsanaCredentials` object.                                                                                                                                                                                                                                                                                                                                      |
| credentials    | Option 1                                | object        | The definition of the `AsanaAccessToken` object.                                                                                                                                                                                                                                                                                                                                      |
| Option 1       | access_token [*required*]          | string        | The `AsanaAccessToken` `access_token`.                                                                                                                                                                                                                                                                                                                                                |
| Option 1       | type [*required*]                  | enum          | The definition of the `AsanaAccessToken` object. Allowed enum values: `AsanaAccessToken`                                                                                                                                                                                                                                                                                              |
| Option 3       | type [*required*]                  | enum          | The definition of the `AsanaIntegrationType` object. Allowed enum values: `Asana`                                                                                                                                                                                                                                                                                                     |
| integration    | Option 4                                | object        | The definition of the `AzureIntegration` object.                                                                                                                                                                                                                                                                                                                                      |
| Option 4       | credentials [*required*]           |  <oneOf> | The definition of the `AzureCredentials` object.                                                                                                                                                                                                                                                                                                                                      |
| credentials    | Option 1                                | object        | The definition of the `AzureTenant` object.                                                                                                                                                                                                                                                                                                                                           |
| Option 1       | app_client_id [*required*]         | string        | The Client ID, also known as the Application ID in Azure, is a unique identifier for an application. It's used to identify the application during the authentication process. Your Application (client) ID is listed in the application's overview page. You can navigate to your application via the Azure Directory.                                                                |
| Option 1       | client_secret [*required*]         | string        | The Client Secret is a confidential piece of information known only to the application and Azure AD. It's used to prove the application's identity. Your Client Secret is available from the application's secrets page. You can navigate to your application via the Azure Directory.                                                                                                |
| Option 1       | custom_scopes                           | string        | If provided, the custom scope to be requested from Microsoft when acquiring an OAuth 2 access token. This custom scope is used only in conjunction with the HTTP action. A resource's scope is constructed by using the identifier URI for the resource and .default, separated by a forward slash (/) as follows:{identifierURI}/.default.                                           |
| Option 1       | tenant_id [*required*]             | string        | The Tenant ID, also known as the Directory ID in Azure, is a unique identifier that represents an Azure AD instance. Your Tenant ID (Directory ID) is listed in your Active Directory overview page under the 'Tenant information' section.                                                                                                                                           |
[...]
